{ **************************************************************
  Datei: FPU_PAS.PAS
  --------------------------------------------------------------
  Autor: Sven Letzel
  Datum: 12.04.1993
  Funktion: Demonstriert die Einbindung von externen Assembler-
            modulen sowie die Programmierung der FPU
  Borland Pascal 7.0 - Zielplattform: Real, Protected, Windows
  **************************************************************}
{$N+,E-}

{$IFDEF Windows} USES WinCrt; {$ENDIF}

{$L FPU.OBJ}
{* Assemblermodul einbinden *}

FUNCTION Berechne(X: EXTENDED): EXTENDED; EXTERNAL;

VAR
  X, Y: EXTENDED;
BEGIN
  WriteLn('DEMO-Program fr externen Assembler.');
  WriteLn('Programmieren der FPU');
  WriteLn('Sie knnen nun Werte fr X eingeben, eine Eingabe von');
  WriteLn('X < -1000 beendet das Programm.');
  WriteLn('Berechnet wird der Funktionswert von f(x)=|2*x^2-3*x+4|'#10);
  REPEAT
    Write('Wert fr X: '); ReadLn(X);
    IF X < -1000 THEN Break;
    Y := Berechne(X);
    WriteLn('f(X) = ',Y,' (',Y:4:4,')');
  UNTIL FALSE;
END.
