{**********************************************************************}
{*                           EINUNDZWANZIG                            *}
{*--------------------------------------------------------------------*}
{* Ziel dieses Spiels ist es, durch geschickte Addition der beiden    *}
{* Werte 1 und 2 das Eregbnis 21 zu erreichen. Dabei wird gegen den   *}
{* Computer gespielt. Wer als erster den Wert 21 erreicht hat, ist    *}
{* Sieger.                                                            *}
{*--------------------------------------------------------------------*}
{* Dateiname:  21.PAS                                                 *}
{**********************************************************************}

PROGRAM Einundzwanzig;

USES Crt;

VAR
     boMyTurn : BOOLEAN;         {* True => Computer ist an der Reihe *}
     iWert : INTEGER;                           { aktueller Spielstand }

PROCEDURE Stand;
BEGIN
     WriteLn('Augenblicklicher Spielstand: ', iWert);
END;

PROCEDURE Spieler;
VAR
     cEingabe : CHAR;
BEGIN

     boMyTurn := FALSE;                       {* Computer darf NICHT! *}

     WriteLn('Um wieviel wollen Sie erhhen - 1 oder 2');
     cEingabe := ReadKey;                  {* auf eine Eingabe warten *}

     CASE cEingabe OF                        {* und Eingabe auswerten *}
        '1':                       {* er mchte also um 1 erhhen ... *}
            BEGIN
            WriteLn('Genehmigt!');
            Inc(iWert);                               {* Wert erhhen *}
            END;
        '2':
           BEGIN                                      {* um 2 erhhen *}
           WriteLn('Sie gehen aber ran!');
           Inc(iWert, 2);
           END;
        ELSE                              {* Falscheingabe! SO Nicht! *}
           WriteLn('Das kann wohl nicht ganz sein.... NOCHMAL!');
           Spieler;                {* Spieler mu Eingabe wiederholen *}
     END;
END;

PROCEDURE Computer;
BEGIN
     boMyTurn := TRUE;                 {* jetzt bin ich endlich dran! *}
                             {* je nach dem augenblicklichen Stand um *}
     CASE iWert OF                          {* um 1 oder um 2 erhhen *}
        1,                {* unsere Kandidaten fr eine Erhhung um 2 *}
        4,
        7,
        10,
        13,
        16,
        19:
        BEGIN
           WriteLn('Ich erhhe um 2!');
           Inc(iWert, 2);                 {* auch tatschlich erhhen *}
        END
        ELSE                  {* in allen brigen Fllen: erhhe um 1 *}
           WriteLn('Ich erhhe um 1!');
           Inc(iWert);
       END;
END;

BEGIN
     ClrScr;                                     {* Bildschirm lschen *}
                                               {* und neu aufbauen... *}
     WriteLn('****************************************************');
     WriteLn('*                   EINUNDZWANZIG                  *');
     WriteLn('*--------------------------------------------------*');
     WriteLn('* Das Ziel des Spiels ist es, durch Addition der   *');
     WriteLn('* beiden Zahlen 1 oder 2 den Wert 21 zu erreichen. *');
     WriteLn('* Derjenige, der diesen als erster erreicht, ist   *');
     WriteLn('* Sieger.                                          *');
     WriteLn('****************************************************');
     WriteLn(^j);

     REPEAT
        iWert := 0;                         {* wir beginnen mit NULL! *}
        Write('Mchten Sie anfangen?');           {* immer hflich... *}
        IF UpCase(ReadKey) = 'J' THEN               {* der Schurke... *}
           boMyTurn := FALSE;                 {* Gegner darf anfangen *}
        WriteLn;
        IF boMyTurn = FALSE THEN            {* Gegner mchte beginnen *}
        BEGIN
           Stand;                  {* augenblicklichen Stand ausgeben *}
           Spieler;                   {* mein Gegner darf beginnen... *}
        END;

        WHILE(iWert < 21) DO        {* solange 21 noch nicht erreicht *}
        BEGIN
           Stand;                  {* augenblicklichen Stand ausgeben *}
           Computer;                       {* jetzt darf der Computer *}

           IF iWert = 21 THEN                   {* schon 21 erreicht? *}
              Break;                  {* Schleife vorzeitig verlassen *}

           Stand;                  {* augenblicklichen Stand ausgeben *}
           Spieler;                   {* mein Gegner ist an der Reihe *}
        END;

        IF boMyTurn = TRUE THEN               {* bin ich gerade dran? *}
           WriteLn('Ich habe gewonnen!')                  {* SIEG!!!! *}
        ELSE                           {* ansonsten habe ich verloren *}
           WriteLn('Gratuliere, Sie haben gewonnen!');

        WriteLn('Mchten Sie noch einmal?');
        boMyTurn := (UpCase(ReadKey) = 'J');

     UNTIL boMyTurn = FALSE;

     WriteLn('Es hat viel Spass gemacht - bis zum nchsten Mal!');

END.


