PROGRAM Lines;

{$X+}
USES WinTypes, WinProcs, Strings, OWindows;

TYPE
  PGDIFenster = ^tGDIFenster;
  tGDIFenster = OBJECT (tWindow)
    PROCEDURE WMLButtonDown (VAR Msg: tMessage); VIRTUAL wm_First + wm_LButtonDown;
    PROCEDURE WMRButtonDown (VAR Msg: tMessage); VIRTUAL wm_First + wm_RButtonDown;
  END;

  tMyApp = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

VAR
  MyApp: tMyApp;

PROCEDURE tMyApp.InitMainWindow;
BEGIN
  MainWindow := New (PGDIFenster, Init(NIL, 'GDI Fenster mit Linien'));
END;

(*  Original : *)
PROCEDURE tGDIFenster.WMLButtonDown (VAR Msg: tMessage);
VAR
  EinDC: hDC;
  R: tRect;
  i: WORD;
  OldPen, NewPen: hPen;
BEGIN
  FOR i := 0 TO 199 DO
  BEGIN
    EinDC := GetDC (hWindow);
    GetClientRect (hWindow, R);
    NewPen := CreatePen (ps_Solid, Random(10), RGB(Random(256), Random(256), Random(256)));
    OldPen := SelectObject(EinDC, NewPen);
    MoveTo (EinDC, Random(R.Right), Random(R.Bottom));
    LineTo (EinDC, Random(R.Right), Random(R.Bottom));
    SelectObject (EinDC, OldPen);
    ReleaseDC (hWindow, EinDC);
    DeleteObject (NewPen);
  END;
END;

PROCEDURE tGDIFenster.WMRButtonDown (VAR Msg: tMessage);
BEGIN
  InvalidateRect (hWindow, NIL, TRUE);
END;

BEGIN
  MyApp.Init ('MyApp');
  MyApp.Run;
  MyApp.Done;
END.
