{$A+,B-,D-,E-,F+,G-,I-,K-,L+,N-,O-,P-,Q-,R-,S+,T-,V+,W-,X+,Y+}
{$M 16384,0}
(*===================================================================*)
(*                         BGIIMPORT.PAS                             *)
(*               Interface-Unit zur DLL BGILIB.PAS                 *)
(*                 (C) 1993 te-wi Verlag Mnchen                     *)
(*===================================================================*)

{$IFNDEF DPMI}
  Fehler: Nur im DMPI-Modus mit Borland Pascal!
{$ENDIF}

UNIT BGIImport;

INTERFACE

CONST
  BGIDLL = 'BGILIB';

VAR
  ScriptFont,
  SimplexFont,      
  TriplexScriptFont,
  ComplexFont,      
  EuropeanFont,     
  BoldFont,         
  UserDriver      : INTEGER;

PROCEDURE CGADriverProc;        
PROCEDURE PC3270DriverProc;     
PROCEDURE VESA16DriverProc;     
PROCEDURE EGAVGADriverProc;     
PROCEDURE ATT400DriverProc;     
PROCEDURE IBM8514DriverProc;    
PROCEDURE HercDriverProc;       
PROCEDURE SVGADriverProc;       
PROCEDURE SmallFontProc;        
PROCEDURE TriplexFontProc;      
PROCEDURE SansSerifFontProc;    
PROCEDURE GothicFontProc;       
PROCEDURE ScriptFontProc;
PROCEDURE SimplexFontProc;      
PROCEDURE TriplexScriptFontProc;
PROCEDURE ComplexFontProc;      
PROCEDURE EuropeanFontProc;     
PROCEDURE BoldFontProc;         

IMPLEMENTATION
USES
  Graph;

PROCEDURE CGADriverProc;        EXTERNAL BGIDLL INDEX 01;
PROCEDURE PC3270DriverProc;     EXTERNAL BGIDLL INDEX 02;
PROCEDURE VESA16DriverProc;     EXTERNAL BGIDLL INDEX 03;
PROCEDURE EGAVGADriverProc;     EXTERNAL BGIDLL INDEX 04;
PROCEDURE ATT400DriverProc;     EXTERNAL BGIDLL INDEX 05;
PROCEDURE IBM8514DriverProc;    EXTERNAL BGIDLL INDEX 06;
PROCEDURE HercDriverProc;       EXTERNAL BGIDLL INDEX 07;
PROCEDURE SVGADriverProc;       EXTERNAL BGIDLL INDEX 08;
PROCEDURE SmallFontProc;        EXTERNAL BGIDLL INDEX 09;
PROCEDURE TriplexFontProc;      EXTERNAL BGIDLL INDEX 10;
PROCEDURE SansSerifFontProc;    EXTERNAL BGIDLL INDEX 11;
PROCEDURE GothicFontProc;       EXTERNAL BGIDLL INDEX 12;
PROCEDURE ScriptFontProc;       EXTERNAL BGIDLL INDEX 13;
PROCEDURE SimplexFontProc;      EXTERNAL BGIDLL INDEX 14;
PROCEDURE TriplexScriptFontProc;EXTERNAL BGIDLL INDEX 15;
PROCEDURE ComplexFontProc;      EXTERNAL BGIDLL INDEX 16;
PROCEDURE EuropeanFontProc;     EXTERNAL BGIDLL INDEX 17;
PROCEDURE BoldFontProc;         EXTERNAL BGIDLL INDEX 18;

BEGIN
  RegisterBGIDriver(@CGADriverProc);
  RegisterBGIDriver(@PC3270DriverProc);
  RegisterBGIDriver(@EGAVGADriverProc);
  RegisterBGIDriver(@ATT400DriverProc);
  RegisterBGIDriver(@IBM8514DriverProc);
  RegisterBGIDriver(@HercDriverProc);
  RegisterBGIFont(@SmallFontProc);
  RegisterBGIFont(@TriplexFontProc);
  RegisterBGIFont(@SansSerifFontProc);
  RegisterBGIFont(@GothicFontProc);

  ScriptFont        := RegisterBGIFont(@ScriptFontProc);
  SimplexFont       := RegisterBGIFont(@SimplexFontProc);
  TriplexScriptFont := RegisterBGIFont(@TriplexScriptFontProc);
  ComplexFont       := RegisterBGIFont(@ComplexFontProc);
  EuropeanFont      := RegisterBGIFont(@EuropeanFontProc);
  BoldFont          := RegisterBGIFont(@BoldFontProc);
END.

(*===================================================================*)