(* ------------------------------------------------------ *)
(*                     TESTBED.PAS                        *)
(*       Demonstration der Verwendung von Ressourcen      *)
(*             (c) 1993 te-wi Verlag, Mnchen             *)
(* ------------------------------------------------------ *)
UNIT TestBed;

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

INTERFACE

USES Objects, Drivers, Menus, Views, MsgBox, App;

CONST
  cmEins  = 101;
  cmZwei  = 102;
  cmDrei  = 103;

TYPE
  tBedApp = OBJECT (tApplication)
    PROCEDURE InitMenuBar; VIRTUAL;
    PROCEDURE DebugBox(e : WORD); VIRTUAL;
  END;

IMPLEMENTATION

  PROCEDURE tBedApp.InitMenuBar;
  VAR
    R : tRect;
  BEGIN
    GetExtent(R);
    R.B.Y := R.A.Y + 1;
    MenuBar := New(pMenuBar, Init(R, NewMenu(
      NewSubMenu('~S~ubs', hcNoContext, NewMenu(
        NewItem('~E~ins', '', kbNoKey, cmEins, hcNoContext,
        NewItem('~Z~wei', '', kbNoKey, cmZwei, hcNoContext,
        NewItem('~D~rei', '', kbNoKey, cmDrei, hcNoContext,
        NIL)))),
      NIL))));
  END;

  PROCEDURE tBedApp.DebugBox(e : WORD);
  VAR
    w : STRING;
  BEGIN
    Str(e, w);
    MessageBox('Event #'+ w, NIL, mfInformation OR mfOkButton);
  END;

END.
(* ------------------------------------------------------ *)
(*                Ende von TESTBED.PAS                    *)

