PROGRAM ReeAccess2;

USES WinTypes, WinProcs, WObjects, ReeFace;

{$R ReeXs2}

TYPE
  PMyWindow = ^TMyWindow;
  TMyWindow = OBJECT (tWindow)
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE Destroy; VIRTUAL;
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE WMTimer (VAR Msg: tMessage); VIRTUAL wm_First + wm_Timer;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

CONSTRUCTOR TMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  Attr.w := 200;
  Attr.h := 70;
END;

PROCEDURE TMyWindow.SetupWindow;
BEGIN
  tWindow.SetupWindow;
  SetTimer (hWindow, 2, 300, NIL);
END;

PROCEDURE TMyWindow.Destroy;
BEGIN
  KillTimer (hWindow, 2);
  tWindow.Destroy;
END;

PROCEDURE TMyWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hIcon := LoadIcon (hInstance, idi_Asterisk);
END;

PROCEDURE TMyWindow.WMTimer (VAR Msg: tMessage);
VAR
  EinDC: hDC;
  Temporary: WORD;
  APChar: ARRAY [0..22] OF CHAR;
BEGIN
  IF (Msg.wParam = 2)
  THEN BEGIN
    InvalidateRect (hWindow, NIL, FALSE);
    EinDC := GetDC (hWindow);
    Temporary := ReeFace.GetValue;
    wvSprintF (APChar, '%3u', Temporary);
    TextOut (EinDC, 5, 10, APChar, 3);
    ReleaseDC (hWindow, EinDC);
  END;
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (PMyWindow, Init(NIL, 'Current Value'));
END;

VAR
  GenericApp: tMyApplication;

BEGIN
  GenericApp.Init ('ReeAccess 2');
  GenericApp.Run;
  GenericApp.Done;
END.
