PROGRAM Accel;

{$R Accel}

USES WinDos, OWindows, ODialogs, WinTypes, WinProcs, Strings;

CONST
  { Command ID }
  idm_About = 100;

TYPE
  pMyWindow = ^tMyWindow;
  tMyWindow = OBJECT (tWindow)
    WhichCursor: BOOLEAN;
    OldCursor: hCursor;
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE About (VAR Msg: tMessage); VIRTUAL cm_First + idm_About;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
    PROCEDURE InitInstance; VIRTUAL;
  END;

VAR
  GenericApp: tMyApplication;


CONSTRUCTOR tMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  WhichCursor := TRUE;
  Attr.Menu := LoadMenu(hInstance, 'Generic');
END;

PROCEDURE tMyWindow.SetupWindow;
BEGIN
  tWindow.SetupWindow;
END;

PROCEDURE tMyWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hIcon := LoadIcon (hInstance, 'MYICON');
  aWndClass.hCursor := LoadCursor (hInstance, 'TREK');
END;

PROCEDURE tMyWindow.About (VAR Msg: tMessage);
VAR Dialog: tDialog;
BEGIN
  Dialog.Init(@Self, 'AboutBox');
  Dialog.Execute;
  Dialog.Done;
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (pMyWindow, Init(NIL, 'Trying Accelerators'));
END;

PROCEDURE tMyApplication.InitInstance;
BEGIN
  tApplication.InitInstance;
  hAccTable := LoadAccelerators (hInstance, 'Accelerate');
  (* the variable HAccTable is defined in the object TApplication *)
END;

BEGIN
  GenericApp.Init ('TryAccel');
  GenericApp.Run;
  GenericApp.Done;
END.
