PROGRAM BmpMenu;

{$R BmpMenu}

USES OWindows, ODialogs, WinTypes, WinProcs;

CONST
  { Command ID }
  idm_About = 100;
  idm_Haegar= 101;
  idm_CheckitOut = 102;
  idm_Test  = 103;

TYPE
  pMyWindow = ^tMyWindow;
  tMyWindow = OBJECT (tWindow)
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE About (VAR Msg: tMessage); VIRTUAL cm_First + idm_About;
    PROCEDURE Haegar (VAR Msg: tMessage); VIRTUAL cm_First + idm_Haegar;
    PROCEDURE CheckitOut (VAR Msg: tMessage); VIRTUAL cm_First + idm_CheckitOut;
    PROCEDURE GimmeMore (VAR Msg: tMessage); VIRTUAL cm_First + idm_Test;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

VAR
  GenericApp: tMyApplication;
  CheckMarkDim: LONGINT;


CONSTRUCTOR tMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  Attr.Menu := LoadMenu(hInstance, 'Generic');
END;

PROCEDURE tMyWindow.SetupWindow;
VAR
  MyMenu: hMenu;
  NewBitmap: hBitmap;
BEGIN
  tWindow.SetupWindow;
  {
  AppendMenu (GetSystemMenu (HWindow, FALSE), mf_Separator, 0, NIL);
  AppendMenu (GetSystemMenu (HWindow, FALSE), mf_String, idm_About, 'About ReeMem...');
  }
  NewBitmap := LoadBitmap (hInstance, 'Haegar4');
  MyMenu := GetMenu (hWindow);
  ModifyMenu (MyMenu, idm_Haegar, mf_ByCommand OR mf_Bitmap, idm_Haegar, pChar(NewBitmap));
  NewBitmap := LoadBitmap (hInstance, 'CheckitOut');
  ModifyMenu (MyMenu, idm_CheckitOut, mf_ByCommand OR mf_Bitmap, idm_CheckitOut, pChar(NewBitmap));
  { CheckMarkDim := GetMenuCheckMarkDimensions; }
  DrawMenuBar (hWindow);
END;

PROCEDURE tMyWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hIcon := LoadIcon (hInstance, 'MYICON');
END;

PROCEDURE tMyWindow.About (VAR Msg: tMessage);
VAR Dialog: tDialog;
BEGIN
  Dialog.Init(@Self, 'AboutBox');
  Dialog.Execute;
  Dialog.Done;
END;

PROCEDURE tMyWindow.Haegar (VAR Msg: tMessage);
VAR
  Dialog: tDialog;
BEGIN
  Dialog.Init (@Self, 'Haegar');
  Dialog.Execute;
  Dialog.Done;
END;

PROCEDURE tMyWindow.CheckitOut (VAR Msg: tMessage);
VAR
  Dialog: tDialog;
BEGIN
  Dialog.Init (@Self, 'Checked');
  Dialog.Execute;
  Dialog.Done;
END;

PROCEDURE tMyWindow.GimmeMore (VAR Msg: tMessage);
VAR
  Buffer: ARRAY [0..40] OF CHAR;
  Size: ARRAY [0..1] OF WORD;
  i: INTEGER;
BEGIN
  Size[0] := CheckMarkDim DIV 65536;
  Size[1] := CheckMarkDim MOD 65536;
  FOR i := 0 TO 40 DO
    Buffer[i] := #0;
  wvSprintF (Buffer, 'CheckMark Dimensions: Hhe : %3u, Breite: %3u', Size);
  MessageBox (hWindow, Buffer, NIL, mb_OkCancel);
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (pMyWindow, Init(NIL, 'Click on Hgar'));
END;

BEGIN
  GenericApp.Init ('ClickViking');
  GenericApp.Run;
  GenericApp.Done;
END.
